/*====================================================================
 
 Objectweb Browser Framework
 Copyright (C) 2000-2004 INRIA & USTL - LIFL - GOAL
 Contact: openccm@objectweb.org
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Lesser General Public
 License as published by the Free Software Foundation; either
 version 2.1 of the License, or any later version.
 
 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 Lesser General Public License for more details.
 
 You should have received a copy of the GNU Lesser General Public
 License along with this library; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 USA
 
 Initial developer(s): Jerome Moroy.
 Contributor(s): ______________________________________.
 
 ---------------------------------------------------------------------
 $Id: ClientCollectionIconProvider.java,v 1.4 2005/09/07 13:59:15 rouvoy Exp $
 ====================================================================*/

package org.objectweb.fractal.explorer.icon;

import javax.swing.Icon;

import org.objectweb.fractal.api.Interface;
import org.objectweb.fractal.api.type.InterfaceType;
import org.objectweb.fractal.explorer.context.ClientCollectionInterfaceContainer;
import org.objectweb.fractal.explorer.context.InterfaceWrapper;
import org.objectweb.util.explorer.api.Entry;

/**
 * 
 * @author <a href="mailto:Romain.Rouvoy@lifl.fr">Romain Rouvoy</a>
 * @version 0.1
 */
public class ClientCollectionIconProvider 
     extends InterfaceIconProvider 
{
    /** Empty constructor. */
    public ClientCollectionIconProvider() {
        super();
        loadFc("ClientCollection");
        loadFc("ClientCollectionMandatory");
        loadFc("ClientCollectionOptional");
    }
    
    // ==================================================================
    //
    // Public methods for IconProvider interface.
    //
    // ==================================================================
    
    /**
     * Provides the appropriate icon.
     */
    public Object newIcon(Object obj) {
        ClientCollectionInterfaceContainer container = (ClientCollectionInterfaceContainer) obj;
        Entry[] entries = container.getEntries(obj) ;
        if (entries.length == 0)
            return (Icon) getIcons().get("ClientCollectionMandatory");
        InterfaceWrapper ciw = null ;
        try {
            ciw = (InterfaceWrapper) entries[0].getValue();
        } catch (ClassCastException ex) {
            ex.printStackTrace();
            //ciw = (InterfaceWrapper) ((InterfaceWrapperContext) entries[0].getValue()).getWrapped(); 
        }
        Interface itf = ciw.getItf();
        InterfaceType itft = (InterfaceType)itf.getFcItfType();
        if (itft.isFcOptionalItf())
            return (Icon) getIcons().get("ClientCollectionOptional");
        return (Icon) getIcons().get("ClientCollection");
    }
}
